;*******************************************************************************************
;    RX_GEN_HT6P20BV3P2.ASM
;
;
;    RECEPTOR RF PARA CONTROLE REMOTOS (CHAVEIRINHOS) COM CI HT6P20B
; 
;    PARA DECODIFICAR UTILIZA UM PIC 12F629 (OPCIONALMENTE UM 12F675, DES-
;    COMENTANDO/COMENTANDO  AS LINHAS CITADAS NO TEXTO).
;
;    CLAUDIO LRIOS        INICIO: 27-07-2012  TERMINO:28-06-2012
;    REVISADO : 05-8-2012 
;    (ELIMINADO 'BUG' QUE TRAVAVA SOB INTERFERENCIA FORTE NA ENTRADA 'RFIN')
;    REVISADO 04-01-2013
;    (ELIMINADO BUG DE FALSA RECEPO COM CDIGO 'FFFFFF'C/ INTERFERNCIAS
;    ELIMINADO BUG DE MAU FUNCIONAMENTO COM CDIGOS DE CONTROLES SEQUENCIAIS)
;    REVISADO EM 16-04-2014
;    APRENDE APENAS 41 CONTROLES E INDICA POR PISCADAS QUE MEMRIA ESTA CHEIA
;    ALTERAO NA FORMA DE APRENDIZADO, MANTENDO ACESO LED PROG AT APRENDER
;    OU SAIR POR TEMPO DE 5 SEGUNDOS.
;******************************************************************************************
;
;   GRAVAR CONTROLE:  APERTE MOMENTNEAMENTE O BOTO 'LEARN' NA PLACA (PINO 4 DO PIC 12F629). 
;   O LED 'LEARN'(PINO 2). APERTE UM DOS BOTES DO CONTROLE A GRAVAR. 
;   AO APRENDER, APAGARA O LED LEARN E ACIONAR A SAIDA. 
;   REPITA ISTO COM OS DEMAIS BOTES DO CONTROLE.
;   FAA ISTO COM  TODOS OS CONTROLES REMOTOS QUE  FOR UTILIZAR, UM POR VEZ.
;   OBS. AO APERTAR BOTO 'LEARN' E EM 5 SEGUNDOS NO HOUVER ACIONAMENTO DE UM CONTROLE
;   A APRENDER,ENTO SAIR DE FORMA AUTOMTICA DO MODO DE PROGRAMAO.
;   APAGAR TODOS OS CONTROLES DA MEMRIA:  APERTAR BOTO 'LEARN' NA PLACA E 
;   MANTENHA PRESSIONADO POR MAIS DE 10 SEGUNDOS.    O LED 'LEARN' (PINO 2) PISCAR
;   3 VEZES , INDICANDO O PLENO APAGAMENTO DE TODOS OS SENSORES DA MEMRIA.
;   APS ISTO, CADA CONTROLE DEVER SER 'REAPRENDIDO' NOVAMENTE PARA OPERAR.
;***************************************************************************************** 
;  ESCOLHA DO MICROCONTROLADOR
#DEFINE  P12F675  ;PARA PIC 12F675 (DESCOMENTE PARA 12F629)

;*****************************************************************************************

    IFDEF P12F675
	LIST P=12f675 , R=DEC
	INCLUDE "P12F675.INC"
    ELSE
 	INCLUDE "P12F629.INC"
	LIST P=12f629 , R=DEC
    ENDIF
;--------------------------
	ERRORLEVEL      -302   
	__CONFIG		_CP_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _BODEN_ON & _MCLRE_OFF


#DEFINE		BANK0	BCF	STATUS,RP0 	 ;SETA BANK0 DE MEMORIA
#DEFINE		BANK1	BSF	STATUS,RP0	 ;SETA BANK1
#DEFINE		FLAG	FLAGS,0          ;FLAG DE SITUAO
#DEFINE		FLAG1	FLAGS,1     	 ;FLAG DE NOVA LEITURA
#DEFINE		FLAGGR	FLAGS,2     	 ;FLAG DE 'LEARN' APRENDER
#DEFINE SIN 		GPIO,0  ;PINO 7  IN RF
#DEFINE LRN  		GPIO,3	;PINO 4  IN LEARN BOTTON
#DEFINE LED  		GPIO,5  ;PINO 2  SAIDA LED 'LEARN'
#DEFINE LED2      	GPIO,2	;PINO 5- SAIDA DO LED2
#DEFINE LED1      	GPIO,1	;PINO 6- SAIDA DO LED1

     CBLOCK  0X20
 RES3,RES2,RES1,RES0,AUX,C3,C2,C1,C0,WS,TEMP,BITCOUNTER,FLAGS,TL0,TL1,TL2,Z2,Z1
  LcdDelayCounter,LcdDelayCounter1,tmpLcdRegister,tmpLcdRegister1,SITUAO
  temp,SDATA,AUX2 ,LC,HC ,CONT,RES3A,RES2A,RES1A,RES0A,X,R0,R1,R2,TMP1,TMP_SALVO
  TMP2,TMP3,ADDRESS,TMP,A1,A2
     ENDC

WRCFG	EQU	B'00000000'	; PORTB: EEPROM WRITE TRI-STATE VALUE
YTRISA	EQU	B'001001'	; PORTA: TRI-STATE VALUE  
TMAX    EQU  .50       ;TEMPO MAXIMO DO SINAL LOW
QBYTE   EQU  .28        ;QUANTIDADE DE BYTES A SER RECEBIDO (22 ADRESS+ 2 DADO+ 4 ANTICODE)
TGR     EQU  .255       ;TEMPO DE BOTO APERTADO PARA APAGAR GRAVAAO
T_DESL_PROG EQU .255     ;TEMPO P/ SAIR DO MODO DE PROGRAMAO


    ORG 0X00
    GOTO START
    ORG 0X04
    RETFIE

START:
	MOVLW   0X07
	MOVWF	CMCON			;DESLIGA COMPARADORES
	CLRF	GPIO			; RESET PORT
	MOVLW	YTRISA			; SETUP PORTA
	TRIS	GPIO
    MOVLW  T_DESL_PROG
    MOVWF  A2  


	IFDEF P12F675
	BANK1
	MOVLW .0
	MOVWF ANSEL  ;LIBERA PORTAS DO AD (somente 12f675)
    BANK0
	ENDIF

	 CLRF   FLAGS   ;APAGA REGISTRADOR DE FLAGS
     MOVLW  TGR
     MOVWF  Z2
     CLRF   Z1      ;LIMPA REGISTRADORES
INICIO:

     
     CLRF  RES3
     CLRF  RES2
     CLRF  RES1
	 CLRF  RES0
     MOVLW  QBYTE  ;PREPARA PARA A RECEPO COM NUMERO DE BITS A RECEBER
	 MOVWF  BITCOUNTER
     
L0
     BCF   FLAG   ;LIMPA FLAG E REGISTRADORES DE RECEPO
     CLRF  HC
     CLRF  LC
L1
;---------------------------------

     BTFSS  LRN   ;TESTA BOTO 'LEARN' APERTADO
     GOTO   TAPAGAMENTO  ;APERTADO, COMEA A CONTAR TEMPO MAX. DE APAGAMENTO
	 MOVLW  TGR
     MOVWF  Z2		;RECARGA DO TEMPO DE APAGAMENTO
     CLRF   Z1      ;LIMPA REGISTRADORES
L1H    
     GOTO    SS5

TAPAGAMENTO       ;APAGAR TODOS OS CONTROLES DA MEMRIA
     BTFSC  LED
     GOTO   PULA67
     BSF    LED        ;ACENDE LED (UMA PISCADA)
     BSF    FLAGGR
     MOVLW  T_DESL_PROG
     MOVWF  A2

PULA67
     DECFSZ Z1,F
     GOTO   L1H  
     DECFSZ Z2,F
     GOTO   L1H
     CALL   APAGAEEPROM ;ATINGIU TEMPO MAXIMO: APAGAR MEMRIA
    
     BSF    LED        ;ACENDE LED (UMA PISCADA)
     MOVLW  .10
     CALL   DELAYM
     BCF    LED        ;APAGA LED
     MOVLW  .10
     CALL   DELAYM
 	 BSF    LED        ;ACENDE LED (UMA PISCADA)
     MOVLW  .10
     CALL   DELAYM
     BCF    LED		   ;APAGA LED
     MOVLW  .10
     CALL   DELAYM
     BSF    LED        ;ACENDE LED (UMA PISCADA)
     MOVLW  .10
     CALL   DELAYM
     BCF    LED	       ;APAGA LED
     MOVLW  .10
     CALL   DELAYM
   	 
     BTFSS  LRN       ;AGUARDA SOLTAR BOTO 'LEARN'
     GOTO   $-1
     BCF    FLAGGR    ;ENCERRA APRENDIZADO
     GOTO INICIO

;===================ROTINA DE RECEPO==========================
SS5:
;A  
     BTFSS  LED           ;TESTA SE DEVE SAIR DO MODO DE PROG AUTOMTICO
     GOTO   PULA62
     DECFSZ  A1,F
     GOTO  PULA62
     DECFSZ  A2,F
     GOTO   PULA62
     BCF    LED
     BCF    FLAGGR
     MOVLW  T_DESL_PROG
     MOVWF  A2  

PULA62


	 
     BTFSS FLAG        ;TESTA FLAG DE HUM/ZERO RECEBIDO
	 GOTO  L2      ;FLAG=0
;--------------------------------
;B
     BTFSS SIN      ;SIN ? TESTA SINAL DE ENTRADA DO RECEPTOR DE RF
	 GOTO  M0       ; SIN=0
;----------------------------------
L2
;C
	 BTFSS SIN      ;SIN ?
     GOTO  LA1      ;SIN=0
;-------------------------------------
;E
	 BSF   FLAG     ;SIN=1
     INCF  HC,F
     BTFSC STATUS,Z
     DECF  HC,F
     GOTO  LA2	   ;VAI CONTAR TEMPO DE 50 MICRO SEGUNDOS
;---------------------------------------------------------
LA1
;D
    INCF  LC,F     ;INCREMENTA REGISTRADOR DE LOW SIGNAL NA ENTRADA RF
    BTFSC STATUS,Z
    DECF  LC,F
LA2
    
	MOVLW  .11  ;.11 = 50 MICROSEG    (ACERTA TEMPO ENTRE LEITURAS DA ENTRADA DE RF)
    MOVWF  CONT
    DECFSZ CONT,F
    GOTO $-1
    GOTO L1




M0
;----------------------------------
;F
    MOVFW  LC		    ;TESTA SE NO PASSOU DO LIMITE MAXIMO DE TEMPO EM LOW NA ENTRADA DE RF
    SUBLW  TMAX
    BTFSS  STATUS,C
    GOTO   INICIO       ;C=0 (-)  -  LC>TMAX (REJEITAR DADO - PAUSA INICIAL)
;F'
 
;-----------------------------------
    
;G
    MOVFW  HC			;OBTEM O VALOR DE 'CARRY'(HUM OU ZERO)
    SUBWF  LC,W
    
    RRF    RES3,F       ;DESLOCA  O BIT NOS REGISTRADORES DE RESULTADO
    RRF    RES2,F
    RRF    RES1,F
    RRF    RES0,F
;-------------------------------------
;H
	
    DECFSZ  BITCOUNTER,F  ;DECREMENTA O CONTADOR DE BITS A SER RECEBIDO
    GOTO   L0             ;LE PROXIMO BIT
    
    MOVLW  .4             ;DESPREZA OS BITS DE 'ANTICODE' 1010
    MOVWF  BITCOUNTER
ACERTA
    BCF    STATUS,C
    RRF    RES3,F
    RRF    RES2,F
    RRF    RES1,F
    RRF    RES0,F        ;RESULTADO FICA SOMENTE EM RES2 A RES0,DESPREZA RES3
	DECFSZ BITCOUNTER,F
    GOTO   ACERTA
	


    BTFSC  FLAG1        ;TESTA SE  A PRIMEIRA OU A SEGUNDA RECEPO
	GOTO   PULA1
    MOVFW  RES2         ;SALVA A PRIMEIRA LEITURA PARA COMPARAO COM UMA SEGUNDA
    MOVWF  RES2A
    MOVFW  RES1
    MOVWF  RES1A    
    MOVFW  RES0
    MOVWF  RES0A	
    BSF   FLAG1			;SETA FLAG DE PRIMEIRA RECEPO

    GOTO  INICIO
PULA1
	BCF FLAG1          ;SEGUNDA RECEPO, COMPARA COM A PRIMEIRA
	MOVFW  RES2
    XORWF  RES2A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC
    MOVFW  RES1
    XORWF  RES1A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC
	MOVFW  RES0
    XORWF  RES0A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC	  ;ERRO DE RECEPO
    GOTO   AO       ;OK - BOA RECEPO

RESETAC
	CLRF   RES3A     ; APAGA RESULTADOS DE COMPARAO
    CLRF   RES2A
    CLRF   RES1A
	CLRF   RES0A
    GOTO INICIO




;-------------------------------------
AO
;===========================================================
;ROTINA PARA ELIMINAR RECEPO 'FFFFFF' (MEMRIA VIRGEM)
    MOVFW  RES2
    XORLW  0XFF
    BTFSS  STATUS,Z
    GOTO   R_CONT
 	MOVFW  RES1
    XORLW  0XFF
    BTFSS  STATUS,Z
    GOTO   R_CONT
 	MOVFW  RES0
    XORLW  0XFF
    BTFSS  STATUS,Z
    GOTO   R_CONT
    GOTO   RESETAC   ;RECEBEU 'FFFFFF' = ERRO

R_CONT
;========================================================
;I
    BTFSS  LRN     ;BOTO EST APERTADO?
    BSF    FLAGGR
    CALL   PPT
   	MOVWF  TMP_SALVO  ; M1
    SUBLW  .0
    BTFSC  STATUS,Z  ;  '0'?
    GOTO   APRENDER    ;NENHUM CONTROLE FOI  GRAVADO
MADDRESS
    MOVFW  TMP_SALVO
	MOVWF  ADDRESS
    CALL   EEREAD
    XORWF  RES2,W      ;COMPARA COM RES2
    BTFSS  STATUS,Z
    GOTO   PROXIMO
    DECF   ADDRESS,F
    MOVFW  ADDRESS
    CALL   EEREAD
    XORWF  RES1,W      ;COMPARA COM RES1
    BTFSS  STATUS,Z
    GOTO   PROXIMO
	DECF   ADDRESS,F
	MOVFW  ADDRESS
    CALL   EEREAD
    XORWF  RES0,W      ;COMPARA COM RES0
    BTFSC  STATUS,Z
    GOTO ACIONAR	   ;ENCONTRADO CONTROLE NA MEMRIA
PROXIMO					;VAI PARA O PROXIMO ENDEREO DE MEMRIA PROCURAR....
    
    
    MOVLW   .3
    SUBWF   TMP_SALVO,F	  ;ACERTA  DE 3 EM 3 A POSIO DE BUSCA NA MEMRIA

	BTFSS  STATUS,C  
	GOTO   APRENDER 

    BTFSS   STATUS,Z
    GOTO   MADDRESS   ;VOLTA A BUSCA
   
    
APRENDER
    BTFSS  FLAGGR    ;TESTA SE BOTO 'LEARN' EST PRESSIONADO
    GOTO   INICIO    ;NO EST.
    CALL   PPT       ;EST, PEGA PONTEIRO
    MOVWF  ADDRESS   ;PEGA O ENDEREO APONTADO
	SUBLW  0X7D  ;0X7E      ;LIMITE MAXIMO DA EEPROM (128-1 /3= 42 BOTES OU 24 CONTROLES)
    BTFSS  STATUS,C
    GOTO   MEM_CHEIA
  ;  CLRF   ADDRESS    ;INICIA SOBREGRAVAO
    INCF   ADDRESS,F        ;SOMA 1
    MOVFW  RES0
    MOVWF  TMP		 ;COLOCA EM 'TMP'
    MOVFW  ADDRESS   ;DA O POSIO DE MEMORIA A SER GRAVADO
    CALL   EEWRITE   ;ROTINA DE ESCRITA NA EEPROM
    INCF   ADDRESS,F ;PROXIMA POSIO DE ESCRITA NA EEPROM
    MOVFW  RES1
    MOVWF  TMP
    MOVFW  ADDRESS 
    CALL   EEWRITE
    INCF   ADDRESS,F
    MOVFW  RES2
    MOVWF  TMP
    MOVFW  ADDRESS 
    CALL   EEWRITE
    MOVFW  ADDRESS
    MOVWF  TMP
    MOVLW  .0
    CALL   EEWRITE  ;GRAVA NOVO ENDEREO DE PONTEIRO
    BCF    FLAGGR
    BTFSS  LRN
    GOTO   $-1
    BCF    LED
    BCF    FLAGGR

    
ACIONAR   
    
	BTFSC  RES2,7  ;TESTA QUAIS BOTES FORAM ACIONADOS NA TRANSMISSO
	BSF    LED1    ;ATIVA  LED1
	BTFSS  RES2,7
	BCF    LED1    ;APAGA LED1
  
	BTFSC  RES2,6
	BSF    LED2   ;ATIVA LED2
	BTFSS  RES2,6
	BCF    LED2   ;APAGA LED2


    MOVLW  .20
    CALL   DELAYM  ;TEMPO QUE SE MANTEM ACESOS
	BCF  LED1 
	BCF  LED2
    GOTO INICIO

;PISCA LED LEARN PARA INDICAR MEMRIA CHEIA
MEM_CHEIA
    MOVLW  .30
    MOVWF  TEMP
LOOP_J5
    BSF   LED
    MOVLW  .2    ;TEMPO DE ATRASO
    CALL   DELAYM
    BCF   LED       ;DESLIGA 
    MOVLW  .2    ;TEMPO DE ATRASO
    CALL   DELAYM
    DECFSZ TEMP,F
    GOTO   LOOP_J5
    BCF    FLAGGR ;APAGA FLAG DE APRENDIZADO
    GOTO   INICIO

;--------------------------------------------------------------
DELAYM
   MOVWF  R0
XC
   CALL  AGUARDE
   DECFSZ R0,F
   GOTO XC
   RETURN

;****************************************************
;PEGA PONTEIRO NA EEPROM - ULTIMO ENDEREO
PPT
    MOVLW .0
    CALL  EEREAD    ;LE  PONTEIRO DA EEPROM
    RETURN

AGUARDE		;ROTINA DE ATRASO ENTRE OPERAES DE EEPROM

	MOVLW  .64
	MOVWF	R1
CG2
	CLRWDT
	MOVLW	.255
	MOVWF	R2
	
	DECFSZ	R2,F
	GOTO $-1
	DECFSZ	R1,F
	GOTO CG2
	RETURN


EEWRITE

; ******* EEPROM WRITE ENABLE ******************
;endereo esta em ADDRESS
;DADOS A ESCREVER ESTA EM TMP(MSB)  


	BANK1
	movwf EEADR	
	BANK0
	MOVFW  TMP		;PEGA PRIMEIRO DADO
	BANK1
	movwf EEDATA
	bcf EECON1, EEIF	
	bsf EECON1, WREN ; enable Write\par
	movlw 0x55	
	movwf EECON2	
	movlw 0xAA	
	movwf EECON2	
	bsf EECON1, WR	
WRITE_SN_A clrwdt	
	btfsc EECON1, WR ; Write complete ?\par
	goto WRITE_SN_A	
	bcf EECON1, WREN ; disable Write\par
 	BANK0

	clrwdt	
	
ESPERA1			;DELAY ENTRE APAGAMENTOS
	CALL  AGUARDE
	RETURN



EEREAD
;endereo esta em ADDRESS
;DADOS LIDOS SERO ESCRITOS EM TMP0
        
	clrwdt	
;	MOVFW  ADDRESS
	
	BANK1
	movwf EEADR	
	bsf EECON1, RD ; do a read\par
	clrwdt
    btfsc EECON1, RD ; Read done ?\par
	goto $-1	
	movf EEDATA,W
	BANK0
	MOVWF	TMP	;RECUPERA PRIMEIRO NUMERO DA EEPROM
	clrwdt	

	RETURN
;------------------------------------------------------------------------------
APAGAEEPROM ;OK TESTADA E APROVADA
; ROTINA PARA APAGAR TODAS AS POSIOES DA EEPROM DO 16F628
	


	MOVLW 0X80		;TOTAL DE 128 + 1 BYTES DE EEPROM
	MOVWF	AUX
RET6
	CLRWDT
	MOVFW	AUX
	MOVLW   .1  ;ACERTA ENDEREO TIRANDO 1
	SUBWF	AUX,W
	BANK1
	movwf EEADR	
	MOVLW	0XFF
	movwf EEDATA
	bcf EECON1, EEIF	
	bsf EECON1, WREN ; enable Write\par
	movlw 0x55	
	movwf EECON2	
	movlw 0xAA	
	movwf EECON2	
	bsf EECON1, WR	
WRITE_SN_C clrwdt	
	btfsc EECON1, WR ; Write complete ?\par
	goto WRITE_SN_C	
	bcf EECON1, WREN ; disable Write\par
 	BANK0
	DECFSZ	AUX,F
	GOTO  ESPERA
	clrwdt	
    MOVLW .0
    MOVWF  TMP
    CALL  EEWRITE  ;ZERA PONTEIRO
	RETLW 0H
ESPERA			;DELAY ENTRE APAGAMENTOS
	MOVLW  .8
	MOVWF	R1
CG1
	MOVLW	.255
	MOVWF	R2
	
	DECFSZ	R2,F
	GOTO $-1
	DECFSZ	R1,F
	GOTO CG1
	GOTO RET6
    
   ORG H'2100' 
   DE  .0   




     end
